/*
 * Awake File: Easy file upload & download through HTTP with Java
 * Awake SQL: Remote JDBC access through HTTP.                                    
 * Copyright (C) 2012, Kawan Softwares S.A.S.
 * (http://www.awakeframework.org). All rights reserved.                                
 *                                                                               
 * Awake File/SQL is free software; you can redistribute it and/or                 
 * modify it under the terms of the GNU Lesser General Public                    
 * License as published by the Free Software Foundation; either                  
 * version 2.1 of the License, or (at your option) any later version.            
 *                                                                               
 * Awake File/SQL is distributed in the hope that it will be useful,               
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             
 * Lesser General Public License for more details.                               
 *                                                                               
 * You should have received a copy of the GNU Lesser General Public              
 * License along with this library; if not, write to the Free Software           
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  
 * 02110-1301  USA
 *
 * Any modifications to this file must keep this entire header
 * intact.
 */

//23/11/12 19:00 NDP : File creation

package org.awakefw.file.api.util;


/**
 * @author Nicolas de Pomereu
 * 
 * Store the default values of some parameters used in Awake File and SQL
 *
 */
public class DefaultParms {


    /** Do not instantiate */
    protected DefaultParms() {
    }
    
    /** Defines one kilobyte */
    private static final int KB = 1024;

    /** Defines one megabyte */
    private static final int MB = 1024 * KB;
    
    /**
     * The default maximum authorized length for a string for upload or download
     */
    public static final int DEFAULT_MAX_LENGTH_FOR_STRING = 2 * MB;
    
    /** The default buffer size when uploading a file */
    public static final int DEFAULT_UPLOAD_BUFFER_SIZE = 20 * KB;
    
    /** The default Buffer size for download and copy */
    public static final int DEFAULT_DOWNLOAD_BUFFER_SIZE = 20 * KB;
    
    /** The default behavior for html encoding */
    public static final boolean DEFAULT_HTML_ENCODING_ON = true;
    
    /** The default acceptance for self signed SSL certificates */
    public static final boolean ACCEPT_ALL_SSL_CERTIFICATES = false;


    
}
