/**
 * 
 */
package org.awakefw.file.servlet;

import java.io.IOException;
import java.sql.SQLException;
import java.util.List;
import java.util.Set;

import org.awakefw.commons.api.server.AwakeCommonsConfigurator;

/**
 * 
 * Calls AwakeCommonsConfigurator methods using reflection
 * 
 * @author Nicolas de Pomereu
 * 
 */
public class AwakeCommonsConfiguratorCall {

	/**
	 * Return the result of forceSecureHttp method of AwakeCommonsConfigurator
	 * 
	 * @param AwakeCommonsConfigurator
	 *            the AwakeCommonsConfigurator instance
	 * @return true if https must be forced, else false
	 * 
	 * @throws SQLException
	 *             if any Exception occurs, it is wrapped into an SQLException
	 */
	public static boolean forceSecureHttp(
			AwakeCommonsConfigurator awakeCommonsConfigurator)
			throws SQLException {
		return awakeCommonsConfigurator.forceSecureHttp();
	}

	/**
	 * Return the result of getBannedUsernames method of
	 * AwakeCommonsConfigurator
	 * 
	 * @param AwakeCommonsConfigurator
	 *            the AwakeCommonsConfigurator instance
	 * @return the list of banned usernames else empty list
	 * 
	 * @throws SQLException
	 *             if any Exception occurs, it is wrapped into an SQLException
	 */
	public static Set<String> getBannedUsernames(
			AwakeCommonsConfigurator awakeCommonsConfigurator)
			throws IOException, SQLException {
		return awakeCommonsConfigurator.getBannedUsernames();
	}

	/**
	 * Return the result of getBannedIPs method of AwakeCommonsConfigurator
	 * 
	 * @param AwakeCommonsConfigurator
	 *            the AwakeCommonsConfigurator instance
	 * @return the list of banned IPs else empty list
	 * 
	 * @throws SQLException
	 *             if any Exception occurs, it is wrapped into an SQLException
	 */

	public static List<String> getBannedIPs(
			AwakeCommonsConfigurator awakeCommonsConfigurator)
			throws IOException, SQLException {
		return awakeCommonsConfigurator.getBannedIPs();
	}

	/**
	 * Return the result of computeAuthToken(String username) method of
	 * AwakeCommonsConfigurator
	 * 
	 * @param AwakeCommonsConfigurator
	 *            the AwakeCommonsConfigurator instance
	 * @return the result of computeAuthToken
	 * 
	 * @throws SQLException
	 *             if any Exception occurs, it is wrapped into an SQLException
	 */
	public static String computeAuthToken(
			AwakeCommonsConfigurator awakeCommonsConfigurator, String username)
			throws Exception {
		return awakeCommonsConfigurator.computeAuthToken(username);
	}

	/**
	 * Return the result of computeAuthToken(String username) method of
	 * AwakeCommonsConfigurator
	 * 
	 * @param AwakeCommonsConfigurator
	 *            the AwakeCommonsConfigurator instance
	 * @return the list of banned IPs else null
	 * 
	 * @throws SQLException
	 *             if any Exception occurs, it is wrapped into an SQLException
	 */
	public static char[] getEncryptionPassword(
			AwakeCommonsConfigurator awakeCommonsConfigurator)
			throws SQLException {
		return awakeCommonsConfigurator.getEncryptionPassword();
	}

}
